# Upcoming meetings for 2021

## Schedule ASAP

- Should we change binding behavior for interpolated string handlers in lower language versions? (333fred, stephentoub) https://github.com/dotnet/roslyn/issues/55345

## Schedule when convenient

- Feature specs and the C# Standard (Mads, Bill, Rex): https://github.com/dotnet/csharpstandard
- Remove restriction that interpolations within a non-verbatim interpolated string cannot contain new-lines. (cyrusn) https://github.com/dotnet/csharplang/issues/4935

## Recurring topics

- *Triage championed features and milestones*
- *Design review*


## Sep 29, 2021

## Sep 27, 2021

## Sep 22, 2021

## Sep 20, 2021

## Sep 15, 2021

## Sep 13, 2021

## Sep 8, 2021

## Sep 1, 2021

## Aug 30, 2021

## Aug 23, 2021

# C# Language Design Notes for 2021

Overview of meetings and agendas for 2021

## Jul 26, 2021

[C# Language Design Notes for July 26th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-07-26.md)

1. Lambda conversion to System.Delegate
2. Direct invocation of lambdas
3. Speakable names for top-level statements

## Jul 19, 2021

[C# Language Design Notes for July 19th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-07-19.md)

1. Global using scoping revisited

## Jul 12, 2021

[C# Language Design Notes for July 12th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-07-12.md)

1. C# 10 Feature Status
2. Speakable names for top-level statements

## Jun 21, 2021

[C# Language Design Notes for June 21st, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-06-21.md)

1. Open questions for lambda return types
2. List patterns in recursive patterns
3. Open questions in async method builder
4. Email Decision: Duplicate global using warnings

## Jun 14, 2021

[C# Language Design Notes for June 14th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-06-14.md)

1. Open questions in CallerArgumentExpressionAttribute
2. List pattern syntax

## Jun 7, 2021

[C# Language Design Notes for June 7th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-06-07.md)

1. Runtime checks for parameterless struct constructors
2. List patterns
    a. Exhaustiveness
    b. Length pattern feedback

## Jun 2, 2021

[C# Language Design Notes for June 2nd, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-06-02.md)

1. Enhanced #line directives
2. Lambda return type parsing
3. Records with circular references

## May 26, 2021

[C# Language Design Notes for May 26th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-26.md)

1. Open questions in list patterns

## May 19, 2021

[C# Language Design Notes for May 19th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-19.md)

1. Triage
    1. Checked operators
    2. Relaxing shift operator requirements
    3. Unsigned right shift operator
    4. Opaque parameters
    5. Column mapping directive
    6. Only allow lexical keywords
    7. Allow nullable types in declaration patterns
2. Protected interface methods

## May 17, 2021

[C# Language Design Notes for May 17th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-17.md)

1. Raw string literals

## May 12, 2021

[C# Language Design Notes for May 12th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-12.md)

1. Experimental attribute
2. Simple C# programs

## May 10, 2021

[C# Language Design Notes for May 10th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-10.md)

- Lambda improvements

## May 3, 2021

[C# Language Design Notes for May 3rd, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-05-03.md)

1. Improved interpolated strings
2. Open questions in record structs

## Apr 28, 2021

[C# Language Design Notes for April 28th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-28.md)

1. Open questions in record and parameterless structs
2. Improved interpolated strings

## Apr 21, 2021

[C# Language Design Notes for April 21st, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-21.md)

1. Inferred types for lambdas and method groups
2. Improved interpolated strings

## Apr 19, 2021

[C# Language Design Notes for April 19th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-19.md)

1. Improved interpolated strings

## Apr 14, 2021

[C# Language Design Notes for April 14th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-14.md)

1. Shadowing in record types
2. `field` keyword
3. Improved interpolated strings

## Apr 12, 2021

[C# Language Design Notes for April 12th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-12.md)

1. List patterns
2. Lambda improvements

## Apr 7, 2021

[C# Language Design Notes for April 7th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-07.md)

- MVP session

## Apr 5, 2021

[C# Language Design Notes for April 5th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-04-05.md)

1. Interpolated string improvements
2. Abstract statics in interfaces

## Mar 29, 2021

[C# Language Design Notes for March 29th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-29.md)

1. Parameterless struct constructors
2. AsyncMethodBuilder

## Mar 24, 2021

[C# Language Design Notes for March 24th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-24.md)

1. Improved interpolated strings
2. `field` keyword

## Mar 22, 2021

- *Design review* (No notes published)

## Mar 15, 2021

[C# Language Design Notes for March 15th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-15.md)

1. Interpolated string improvements
2. Global usings

## Mar 10, 2021

[C# Language Design Notes for March 10th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-10.md)

1. Property improvements
    1. `field` keyword
    2. Property scoped fields
2. Parameterless struct constructors

## Mar 3, 2021

[C# Language Design Notes for March 3rd, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-03.md)

1. Natural type for lambdas
    1. Attributes
    2. Return types
    3. Natural delegate types
2. Required members

## Mar 1, 2021

[C# Language Design Notes for March 1st, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-03-01.md)

1. Async method builder override
2. Async exception filters
3. Interpolated string improvements

## Feb 24, 2021

[C# Language Design Notes for February 24th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-02-24.md)

1. Static abstract members in interfaces

## Feb 22, 2021

[C# Language Design Notes for February 22nd, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-02-22.md)

1. Global `using`s
2. `using` alias improvements

## Feb 10, 2021

[C# Language Design Notes for February 10th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-02-10.md)

1. Follow up on record equality
2. Namespace directives in top-level programs
3. Global usings
4. Triage
    1. Nominal And Collection Deconstruction
    2. Sealed record ToString
    3. `using` aliases for tuple syntax
    4. Raw string literals
    5. Allow `var` variables to be used in a `nameof` in their initializers
    6. First-class native integer support
    7. Extended property patterns

## Feb 8, 2021

[C# Language Design Notes for February 8th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-02-08.md)

1. Virtual statics in interfaces
    1. Syntax Clashes
    2. Self-applicability as a constraint
    3. Relaxed operator operand types
    4. Constructors

## Feb 3, 2021

[C# Language Design Notes for February 3rd, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-02-03.md)

1. List patterns on `IEnumerable`
2. Global usings

## Jan 27, 2021

[C# Language Design Notes for January 27th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-01-27.md)

1. Init-only access on conversion on `this`
2. Record structs
    1. Copy constructors and Clone methods
    2. `PrintMembers`
    3. Implemented equality algorithms
    4. Field initializers
    5. GetHashcode determinism

## Jan 13, 2021

[C# Language Design Notes for January 13th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-01-13.md)

- Global usings
- File-scoped namespaces

## Jan 11, 2021

[C# Language Design Notes for January 11th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-01-11.md)

- Required properties simple form

## Jan 6, 2021

[C# Language Design Notes for January 5th, 2021](https://github.com/dotnet/csharplang/blob/main/meetings/2021/LDM-2021-01-05.md)

- File scoped namespaces
